package co.hyperverge.hyperkyc_flutter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import co.hyperverge.hyperkyc.data.models.HyperKycConfig;
import co.hyperverge.hyperkyc.data.models.HyperKycFlow;

public class FLHyperKyc {
    public static final String TAG = FLHyperKyc.class.getCanonicalName();

    public HyperKycConfig getHyperKycConfigFromMap(Map<String, Object> hyperKycConfigMap) {
        String appId = (String) hyperKycConfigMap.get("appId");
        String accessToken = (String) hyperKycConfigMap.get("accessToken");
        String transactionId = (String) hyperKycConfigMap.get("transactionId");

        String[] workFlowComponents = ((String) hyperKycConfigMap.get("workFlow")).split(",");
        List<HyperKycFlow> workFlow = getWorkFlowFromComponents(workFlowComponents);
        return new HyperKycConfig(appId, accessToken, workFlow, transactionId);
    }

    private List<HyperKycFlow> getWorkFlowFromComponents(String[] workFlowComponents) {
        List<HyperKycFlow> hyperKycFlow = new ArrayList<>();
        for (String workFlowComponent : workFlowComponents) {
            hyperKycFlow.add(getWorkFlowEnum(workFlowComponent));
        }
        return hyperKycFlow;
    }

    private HyperKycFlow getWorkFlowEnum(String workFlowComponent) {
        switch (workFlowComponent) {
            case "document":
                return HyperKycFlow.DOCUMENT;
            case "face":
                return HyperKycFlow.FACE;
            default:
                return HyperKycFlow.DOCUMENT;
        }
    }
}
