//
//  FLHyperKyc.swift
//  hyperkyc_flutter
//
//  Created by Shrirama Upadhya A on 22/01/22.
//

import Foundation
import HyperKYC

class FLHyperKyc {
    
    public static func launch(context: UIViewController, hyperKycConfigArgument : [String: Any], callback: @escaping ((HyperKycResult)->Void)){
        
        let appId = hyperKycConfigArgument["appId"] as! String
        let accessToken = hyperKycConfigArgument["accessToken"] as! String
        let transactionId = hyperKycConfigArgument["transactionId"] as! String
        let workFlowArgument = hyperKycConfigArgument["workFlow"] as! String
        
        let workFlowComponents = workFlowArgument.components(separatedBy: ",")
        let workFlow = getWorkFlowFromComponents(workFlowComponents: workFlowComponents)
        
        let hyperKycConfig = HyperKycConfig(appId: appId, accessToken: accessToken, workFlow: workFlow, transactionId: transactionId)
        
        HyperKyc.launch(context, hyperKycConfig: hyperKycConfig, callback)
    }
    
    static func getWorkFlowFromComponents(workFlowComponents: [String]) -> [HyperKycFlow] {
        var workFlow = [HyperKycFlow]()
        for workFlowComponent in workFlowComponents {
            workFlow.append(getWorkFlowEnum(workFlowComponent: workFlowComponent))
        }
        return workFlow
    }
    
    static func getWorkFlowEnum(workFlowComponent: String) -> HyperKycFlow {
        switch workFlowComponent {
        case "document":
            return HyperKycFlow.document
        case "face":
            return HyperKycFlow.face
        default : return HyperKycFlow.document
        }
        
    }
    
}
